--*************************************************
--**	Copyright (C) 2002 SENG digitale Syteme GmbH
--**
--**	SENG digitale Systeme GmbH
--**	Im Bruckwasen 35
--**	D 73037 Goeppingen
--**	Germany
--**	http://www.seng.de
--*************************************************


-- Addressdecoder, synchronous

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity DecMM0 is
	Port ( 
		CLK: in STD_LOGIC;
		nWR: in STD_LOGIC;
		A_IN: in STD_LOGIC_VECTOR(7 downto 0); 
		EN_OUT: out STD_LOGIC
	);
end DecMM0;


architecture Behavioral of DecMM0 is
begin

	process(CLK)
	begin
		if ( CLK'event and CLK ='1') then
			if (nWR = '1' ) then 
		   	EN_OUT <= '0';
			else
				case A_IN is
				   when "00000000" => EN_OUT <= '1'; -- address==0x0
				   when others => EN_OUT <= '0'; -- address==0x1..0xFF
				end case;
			end if;
		end if;
	end process;

end Behavioral;


