--*************************************************
--**	Copyright (C) 2002 SENG digitale Syteme GmbH
--**
--**	SENG digitale Systeme GmbH
--**	Im Bruckwasen 35
--**	D 73037 Goeppingen
--**	Germany
--**	http://www.seng.de
--*************************************************


-- Addressdecoder, synchronous
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity DecMMadr is
	Port ( 
		CLK: in STD_LOGIC;		
		nWR: in STD_LOGIC;
		A_IN: in STD_LOGIC_VECTOR(7 downto 0); 
		EN_0: out STD_LOGIC; 
		EN_1: out STD_LOGIC;
		EN_2: out STD_LOGIC; 
		EN_3: out STD_LOGIC;
		EN_4: out STD_LOGIC; 
		EN_5: out STD_LOGIC;
		SEL: out STD_LOGIC_VECTOR(1 downto 0)
	);
end DecMMadr;


architecture Behavioral of DecMMadr is
begin

	decode: process(CLK,nWR,A_IN)
	begin
		if ( CLK'event and CLK ='1') then
			if (nWR = '1' ) then 
		   	EN_0 <= '0';
				EN_1 <= '0';
				EN_2 <= '0';
				EN_3 <= '0';
				EN_4 <= '0';
				EN_5 <= '0';
			else
				
				if ( A_IN = "00000001" ) then EN_0 <= '1'; -- address==0x1
    			else EN_0 <= '0';
    			end if;

				if ( A_IN = "00000011" ) then EN_1 <= '1'; -- address==0x3
    			else EN_1 <= '0';
    			end if;				

				if ( A_IN = "00000100" ) then EN_2 <= '1'; -- address==0x4
    			else EN_2 <= '0';
    			end if;

				if ( A_IN = "00000101" ) then EN_3 <= '1'; -- address==0x5
    			else EN_3 <= '0';
    			end if;
				
				if ( A_IN = "00000110" ) then EN_4 <= '1'; -- address==0x6
    			else EN_4 <= '0';
    			end if;

				if ( A_IN = "00000010" ) then EN_5 <= '1'; -- address==0x2
    			else EN_5 <= '0';
    			end if;

			end if;
		end if;
	end process;

	encode: process(CLK,A_IN)
	begin
		if ( CLK'event and CLK ='1') then
			case A_IN is
		      when "00000001" => SEL <= "00"; -- address==0x1 --> ConfigData
		      when "00000010" => SEL <= "01"; -- address==0x2 --> FlashData, data to Flash
		      when "00000011" => SEL <= "10"; -- address==0x3 --> D(7:0), data from Flash
		      when others => SEL <= "00"; -- address==0x0,0x4..0xFF --> ConfigData
		   end case;
		end if;
	end process;

end Behavioral;


 

