--*************************************************
--**	Copyright (C) 2003 SENG digitale Syteme GmbH
--**
--**	SENG digitale Systeme GmbH
--**	Im Bruckwasen 35
--**	D 73037 Goeppingen
--**	Germany
--**	http://www.seng.de
--*************************************************


-- 3 to 1 bus multiplexer 8-bit output with, byte and bit input withs
-- design with case construct

 
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;



entity Mux3x8 is
	Port ( 
--		CLK: in STD_LOGIC;
		A: in STD_LOGIC_VECTOR(7 downto 0);
		B,C: in STD_LOGIC;
		SEL: in STD_LOGIC_VECTOR(1 downto 0);
		O: out STD_LOGIC_VECTOR(7 downto 0)
	);
end Mux3x8;



architecture Behavioral of Mux3x8 is
SIGNAL B8,C8: STD_LOGIC_VECTOR(7 downto 0); -- define bytewide signals 

begin


changeWith: process (B, C)
begin
	if (B = '1') then
		B8 <= "00000001"; -- make byte from bit
	else
		B8 <= "00000000"; -- make byte from bit
	end if;
	if (C = '1') then
		C8 <= "00000001"; -- make byte from bit
	else
		C8 <= "00000000";	-- make byte from bit
	end if;
end process changeWith;


process (A, B8, C8, SEL)
begin
--	if ( CLK'event and CLK ='1') then
	case SEL is
      when "00" => O <= A;
      when "01" => O <= B8;
		when "10" => O <= C8;
	   when others => O <= A;
   end case;
--	end if;
end process;


end Behavioral;

