--*************************************************
--**	Copyright (C) 2002 SENG digitale Syteme GmbH
--**
--**	SENG digitale Systeme GmbH
--**	Im Bruckwasen 35
--**	D 73037 Goeppingen
--**	Germany
--**	http://www.seng.de
--*************************************************

-- Only XST supports RAM inference
-- Infers Single Port Block Ram 
-- Synchronous RAM 32Kbit, 4Kx8

 
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity RAM4Kx8 is 
port (clk : in std_logic; 
we  : in std_logic; 
a   : in std_logic_vector(11 downto 0); 
di  : in std_logic_vector(7 downto 0); 
do  : out std_logic_vector(7 downto 0)); 
end RAM4Kx8; 


architecture syn of RAM4Kx8 is 

type ram_type is array (4095 downto 0) of std_logic_vector (7 downto 0); 
signal RAM : ram_type; 
signal read_a : std_logic_vector(11 downto 0); 

begin 
process (clk) 
begin 
if (clk'event and clk = '1') then 
	if (we = '1') then 
		RAM(conv_integer(a)) <= di; 
	end if; 
	read_a <= a; 
end if; 
end process; 

do <= RAM(conv_integer(read_a));

end syn;









